﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

; you can use alt-tab and win-tab when the command-tab switcher is open!

#NoTrayIcon
#Persistent
#SingleInstance, Force

TrackpadFix := 0
DrivesOnDesktop := 1
TitleBarMenu := 1
AppSwitchIconSize := 32

; to do next:
; √ command-H minimizes all of the windows? that won't restore properly and won't work for windows that can't be minimized, but it's better than nothing
; quick look previews?
; command-tilde is still a bit flaky, and command-tab needs to be redone
; command-tilde does not work on the Desktop
; command-M to minimize the current window and bring the next window from the same app to the front, or the next app if there are no more windows
; what is control-left, down, etc. used for on the mac? should we retain the windows behavior?
; hitting enter to rename seems to not be working due to the active window, not the internal state of this code
; we can eventually have spring-loaded folders by sending a double-click to the target of a drag operation whenever the mouse stops moving!
; command-tilde switching predictably fails when dealing with floating windows

; alright, i've lost motivation for this...

; hm, every hotkey runs in its own thread! this will take a bit more work to disable the right keys at the right time!
; for example, while i'm holding down option-e i can press option-i or anything else
; is this app leaking memory anywhere?
; we definitely have re-entrancy problems
; X show the transparent volume thingy? and brightness?

; i'm pretty sure we need to keep track of the open programs and their minimized states
; then whenever we call UpdateWindows we need to switch back and forth between two arrays and copy over the differences
; then when we choose to activate an app, or when we get an event for a window belonging to that app activating, we need to re-show and restore any windows we flagged as being hidden by this app

; use the nicer icon for File Explorer, and √ rename Windows Explorer to File Explorer

; relaunch WizMouse as needed
; command-delete is a little flaky, and might be related to the {Shift down}{Shift up} stuff that causes a desync in the key states
; ? the computer does not behave well on battery power
; we need to update the window every second or so, and resize it and whatnot (or we can use event triggers)
; when we update the list of open windows, we should keep the same app highlighted if possible
; and eventually implement exposé! and even more eventuallier, mission control!
; when we close a window, bring the next recent window from the same app to the front, or the Desktop if no apps are left
; screenshots with shift-command-3 and shift-command-4 and the spacebar
; command-N in various apps to spawn a new instance, especially WordPad (and open up the default document)
; auto-save documents every so often
; create aliases with command-L
; shift-command-F for a new window with the search field highlighted
; shift-command-G for the Go to Folder option
; command-E to eject a drive?
; option-shift-tilde is not yet implemented
; X then disable the four corners
; shift-command-A can't scroll on the window that appears! why not?
; for programs that respond to command-Z and command-Y, but do not respond to shift-command-Z, map shift-command-Z to command-Y (for redo, most likely)
; do the command-option buttons accept the escape key to cancel? it didn't accept command-Z to undo
; http://forums.codeguru.com/showthread.php?480710-How-to-hook-drag-and-drop-functionality-of-windows

; main():
   SetKeyDelay -1
   switcher := 0
   switcher_active := 0
   switcher_visible := 0
   controltab_active := 0
   expose_active := 0
   key_repeating := 0
   if (TrackpadFix = 1)
      OnMessage(0x218, "PowerProc")
   if (DrivesOnDesktop)
      OnMessage(0x219, "DeviceProc")
   SetTimer WizMouseProc, 5000 ; every 5 seconds check to make sure WizMouse is still running
   ;DllCall("SetWindowsHookEx", int, 5, ptr, RegisterCallback("GlobalWndProc", "F"), uint, 0, uint, 0)
   ;error := DllCall("GetLastError")
   ;MsgBox, %error%
   
   if (TitleBarMenu = 1) {
      ; this includes a modified TBarIconBlanker, to add a gray menu to the left of each titlebar
      DetectHiddenWindows, Off
      Gui +LastFound
      hWnd := WinExist()
      
      ; hook the shell (http://www.autohotkey.com/forum/viewtopic.php?p=123323#123323)
      DllCall("RegisterShellHookWindow", uint, hWnd)
      MsgNum := DllCall("RegisterWindowMessage", str, "SHELLHOOK")
      OnMessage(MsgNum, "ShellMessage")
      menu_icon := DllCall("LoadImageW", uint, 0, str, "C:\Program Files\Utilities\Images\menu.ico", uint, 1, int, 0, int, 0, uint, 0x10 | 0x40)
      explorer_icon := DllCall("LoadImageW", uint, 0, str, "C:\Program Files\Utilities\Images\start.ico", uint, 1, int, 0, int, 0, uint, 0x10 | 0x40)
      
      ; initial loop to blank out existing windows.
      WinGet, s, List
      Loop, % s {
         s := s%A_Index%
         ;SendMessage, 0x80, 0, menu_icon, , % "ahk_id " . s
      }
   }
   return

;WH_KEYBOARD := 2
;WH_CBT      := 5
;WH_MOUSE    := 7

;HC_ACTION   := 0
;HC_NOREMOVE := 3

;DetectHiddenWindows, On
;Process, Exist
;hAHK := WinExist("ahk_pid " . ErrorLevel)

;WM_AHK_Callback := DllCall("RegisterWindowMessage", "str", "WM_AHK_Callback")
;OnMessage(WM_AHK_Callback + HC_ACTION  , "KeybdHook")
;OnMessage(WM_AHK_Callback + HC_NOREMOVE, "KeybdHook")

;DllCall("LoadLibrary", "str", "ahkhook.dll")
;error := DllCall("GetLastError")
;hHook := DllCall("ahkhook\reghook", "Uint", WH_KEYBOARD, "Uint", hAHK, "Uint", WM_AHK_Callback, "Uint", 1<<HC_ACTION|1<<HC_NOREMOVE)
;return

;#End::
;DllCall("UnhookWindowsHookEx", "Uint", hHook)
;DllCall("FreeLibrary", "Uint", DllCall("GetModuleHandle", "str", "ahkhook.dll"))
;ExitApp

;KeybdHook(wParam, lParam, nMsg)
;{
	;Critical
	;Global WM_AHK_Callback
	;MsgBox, % wParam . "|" . lParam . "|" . nMsg - WM_AHK_Callback
	;Return 0
;}

F11::#d                           ; cheapo "Show Desktop" Exposé feature!
F12::LWin                           ; the Start Screen is sorta like Launchpad and Dashboard combined, so let's use that
;F12::
;   Run "C:\Users\Mike McFadden\Desktop\Development\Power\Power.exe"
;   return

#if switcher_active = 0
^q::SendInput !{F4}			; quit programs using command-Q
^Space::SendInput {LWin down}f{LWin up}	; command-space for the full-screen Files search
!^Esc::SendInput {Control down}{Shift down}{Esc}{Shift up}{Control up} ; command-option-escape to Force Quit

#if switcher_active = 0 and (WinActive("ahk_class Progman") or WinActive("ahk_class CabinetWClass"))
;^+Backspace::				; shift-command-delete to empty the Recycle Bin
;   SHERB_NOCONFIRMATION := 0x00000001
;   SHERB_NOPROGRESSUI := 0x00000002
;   SHERB_NOSOUND := 0x00000004
;   DllCall("Shell32\SHEmptyRecycleBinA", uint, 0, uint, 0, uint, SHERB_NOCONFIRMATION)
;   return

#if switcher_active = 0 and (WinActive("ahk_class Progman") or WinActive("ahk_class CabinetWClass")) and ActiveControlIsOfClass("Edit") = false
;^Backspace::SendInput {Delete}		; command-backspace to move files to the Recycle Bin
^I::SendInput {Alt down}{Enter}{Alt up}	; command-I for the Properties dialog
;Return::F2				; rename files by pressing return
^Down::SendInput {Enter}		; open files with command-down or command-O
^O::SendInput {Enter}
;^L::					; command-L to create a shortcut

;^+F::					; shift-command-F for the Explorer search
   ;Run "C:\" ; we need to wait for the window somehow, possibly by waiting for the active window trigger event?
   ;SendInput {Shift down}{Tab}{Tab}{Shift up}
   ;return

;^+G::					; shift-command-G for Go to Folder
^+A::Run "C:\Program Files"		; shift-command-A for the Applications folder
^+O::ShowUserFolder("\Documents")	; shift-command-O for the Documents folder
^+D::ShowUserFolder("\Desktop")		; shift-command-D for the Desktop folder
^+L::ShowUserFolder("\Downloads")	; shift-command-L for the Downloads folder
^+H:: ShowUserFolder("")		; shift-command-H for the Home folder
^N::ShowUserFolder("")			; command-N for the Home folder as well
^+C::SendInput {LWin down}e{LWin up}	; shift-command-C for the My Computer folder
^+K::					; shift-command-L for the Network folder
   network := "C:\Windows\explorer.exe /e,::{F02C1A0D-BE21-4350-88B0-7367FC96EF3C}"
   Run %network%
   return
;^+U:: ; shift-command-U for the Utilities folder (maybe the Start Menu folder?)

; command-up for the enclosing folder
#if switcher_active = 0 and WinActive("ahk_class Progman") and ActiveControlIsOfClass("Edit") = false
^Up::ShowUserFolder("")
#if switcher_active = 0 and WinActive("ahk_class CabinetWClass") and ActiveControlIsOfClass("Edit") = false
^Up::SendInput {Alt down}{Up}{Alt up}

#if switcher_active = 0 and ((WinActive("ahk_class Progman") = false and WinActive("ahk_class CabinetWClass") = false) or (ActiveControlIsOfClass("Edit") and switcher_active = 0))
; Mac-style text editing
^Right::SendInput {End}
^+Right::SendInput {Shift down}{End}{Shift up}
^Left::SendInput {Home}
^+Left::SendInput {Shift down}{Home}{Shift up}
!Right::SendInput {Control down}{Right}{Control up}
!+Right::SendInput {Control down}{Shift down}{Right}{Shift up}{Control up}
!Left::SendInput {Control down}{Left}{Control up}
!+Left::SendInput {Control down}{Shift down}{Left}{Shift up}{Control up}
^Up::SendInput {PgUp}
^+Up::SendInput {Shift down}{PgUp}{Shift up}
^Down::SendInput {PgDn}
^+Down::SendInput {Shift down}{PgDn}{Shift up}
!Enter::SendInput +{Enter} ; option-enter is mapped to shift-enter (used for multiline comments on Facebook)
^Backspace::SendInput {Shift down}{Home}{Shift up}{Backspace}
!Backspace::SendInput {Control down}{Shift down}{Left}{Shift up}{Control up}{Backspace}

; use the option key for special characters
!u::
  SendInput ¨{Shift down}{Left}{Shift up}
  Input, x, L1 M, {Left}{Right}{Up}{Down}{Del}{BS}
  StringCaseSense On
  IfInString, ErrorLevel, EndKey:
  {
    StringReplace, key, ErrorLevel, EndKey:
    SendInput ¨{%key%}
  }
  else IfEqual x, u, SendInput ü
  else IfEqual x, U, SendInput Ü
  else IfEqual x, i, SendInput ï
  else IfEqual x, I, SendInput Ï
  else IfEqual x, o, SendInput ö
  else IfEqual x, O, SendInput Ö
  else IfEqual x, y, SendInput ÿ
  else IfEqual x, Y, SendInput Ÿ
  else IfEqual x, e, SendInput ë
  else IfEqual x, E, SendInput Ë
  else IfEqual x, a, SendInput ä
  else IfEqual x, A, SendInput Ä
  else SendInput ¨%x%
  return

!e::
  SendInput ´{Shift down}{Left}{Shift up}
  Input, x, L1 M, {Left}{Right}{Up}{Down}{Del}{BS}
  StringCaseSense On
  IfInString, ErrorLevel, EndKey:
  {
    StringReplace, key, ErrorLevel, EndKey:
    SendInput ´{%key%}
  }
  else IfEqual x, e, SendInput é
  else IfEqual x, E, SendInput É
  else IfEqual x, u, SendInput ú
  else IfEqual x, U, SendInput Ú
  else IfEqual x, i, SendInput í
  else IfEqual x, I, SendInput Í
  else IfEqual x, o, SendInput ó
  else IfEqual x, O, SendInput Ó
  else IfEqual x, a, SendInput á
  else IfEqual x, A, SendInput Á
  else SendInput ´%x%
  return

!i::
  SendInput ˆ{Shift down}{Left}{Shift up}
  Input, x, L1 M, {Left}{Right}{Up}{Down}{Del}{BS}
  StringCaseSense On
  IfInString, ErrorLevel, EndKey:
  {
    StringReplace, key, ErrorLevel, EndKey:
    SendInput ˆ{%key%}
  }
  else IfEqual x, e, SendInput ê
  else IfEqual x, E, SendInput Ê
  else IfEqual x, u, SendInput û
  else IfEqual x, U, SendInput Û
  else IfEqual x, i, SendInput î
  else IfEqual x, I, SendInput Î
  else IfEqual x, o, SendInput ô
  else IfEqual x, O, SendInput Ô
  else IfEqual x, a, SendInput â
  else IfEqual x, A, SendInput Â
  else SendInput ˆ%x%
  return

!n::
  SendInput ˜{Shift down}{Left}{Shift up}
  Input, x, L1 M, {Left}{Right}{Up}{Down}{Del}{BS}
  StringCaseSense On
  IfInString, ErrorLevel, EndKey:
  {
    StringReplace, key, ErrorLevel, EndKey:
    SendInput ˜{%key%}
  }
  else IfEqual x, n, SendInput ñ
  else IfEqual x, N, SendInput Ñ
  else IfEqual x, o, SendInput õ
  else IfEqual x, O, SendInput Õ
  else IfEqual x, a, SendInput ã
  else IfEqual x, A, SendInput Ã
  else SendInput ˜%x%
  return

!`::
  SendInput ``{Shift down}{Left}{Shift up}
  Input, x, L1 M, {Left}{Right}{Up}{Down}{Del}{BS}
  StringCaseSense On
  IfInString, ErrorLevel, EndKey:
  {
    StringReplace, key, ErrorLevel, EndKey:
    SendInput ``{%key%}
  }
  else IfEqual x, a, SendInput à
  else IfEqual x, A, SendInput À
  else IfEqual x, e, SendInput è
  else IfEqual x, E, SendInput È
  else IfEqual x, i, SendInput ì
  else IfEqual x, I, SendInput Ì
  else IfEqual x, o, SendInput ò
  else IfEqual x, O, SendInput Ò
  else IfEqual x, u, SendInput ù
  else IfEqual x, U, SendInput Ù
  else IfEqual x, n, SendInput ǹ
  else IfEqual x, N, SendInput Ǹ
  else IfEqual x, w, SendInput ẁ
  else IfEqual x, W, SendInput Ẁ
  else IfEqual x, y, SendInput ỳ
  else IfEqual x, Y, SendInput Ỳ
  else SendInput ``%x%
  return

!q::SendInput œ
!w::SendInput ∑
!r::SendInput ®
!t::SendInput †
!y::SendInput ¥
!o::SendInput ø
!p::SendInput π
![::SendInput “
!]::SendInput ‘
!\::SendInput «
!a::SendInput å
!s::SendInput ß
!d::SendInput ∂
!f::SendInput ƒ
!g::SendInput ©
!h::SendInput ˙
!j::SendInput ∆
!k::SendInput ˚
!l::SendInput ¬
!;::SendInput …
!'::SendInput æ
!z::SendInput Ω
!x::SendInput ≈
!c::SendInput ç
!v::SendInput √
!b::SendInput ∫
!m::SendInput µ
!,::SendInput ≤
!.::SendInput ≥
!/::SendInput ÷
!1::SendInput ¡
!2::SendInput ™
!3::SendInput £
!4::SendInput ¢
!5::SendInput ∞
!6::SendInput §
!7::SendInput ¶
!8::SendInput •
!9::SendInput ª
!0::SendInput º
!-::SendInput –
!=::SendInput ≠
;!`::SendInput `
!+q::SendInput Œ
!+w::SendInput „
!+r::SendInput ‰
!+t::SendInput ˇ
!+y::SendInput Á
!+o::SendInput Ø
!+p::SendInput ∏
!+[::SendInput ”
!+]::SendInput ’
!+\::SendInput »
!+a::SendInput Å
!+s::SendInput Í
!+d::SendInput Î
!+f::SendInput Ï
!+g::SendInput ˝
!+h::SendInput Ó
!+j::SendInput Ô
!+k::SendInput 
!+l::SendInput Ò
!+;::SendInput Ú
!+'::SendInput Æ
!+z::SendInput ¸
!+x::SendInput ˛
!+c::SendInput Ç
!+v::SendInput ◊
!+b::SendInput ı
!+m::SendInput Â
!+,::SendInput ¯
!+.::SendInput ˘
!+/::SendInput ¿
!+1::SendInput ⁄
!+2::SendInput €
!+3::SendInput ‹
!+4::SendInput ›
!+5::SendInput ﬁ
!+6::SendInput ﬂ
!+7::SendInput ‡
!+8::SendInput °
!+9::SendInput ·
!+0::SendInput ‚
!+-::SendInput —
!+=::SendInput ±
;!+`::SendInput ` ; this needs to be implemented

;  +a::
;  a::
   ;  if (key_repeating = 0) {
      ;  key_repeating := 1
      ;  SendInput, %A_ThisHotKey%
      ;  KeyWait, %A_ThisHotKey%, T0.5
      ;  if (ErrorLevel = 1) {
         ; key repeat!
         ;  SendInput, {Shift down}{Left}{Shift up}
         ;  VarSetCapacity(gui_thread, 48, 0)
         ;  NumPut(48, gui_thread, 0)
         ;  DllCall("GetGUIThreadInfo", int, 0, ptr, &gui_thread)
         ;  VarSetCapacity(gui_point, 8, 0)
         ;  NumPut(NumGet(gui_thread, 32, true), gui_point, 0)
         ;  NumPut(NumGet(gui_thread, 44, true), gui_point, 4)
         ;  DllCall("ClientToScreen", ptr, NumGet(gui_thread, 28, true), ptr, &gui_point)
         ;  x := NumGet(gui_point, 0, true)
         ;  y := NumGet(gui_point, 4, true)
         ; now we can use this input to display a popover panel for selecting related diacritics, if we want!
         
         ;  KeyWait, %A_ThisHotKey%
      ;  }
      ;  key_repeating := 0
   ;  }
   ;  return

WizMouseProc:
   ; if WizMouse is no longer running, relaunch the exe
   return

; disable the alt and windows keys on their own
LWin::
RWin::
+LWin::
+RWin::
#Left::
#Right::
#Up::
#Down::
Alt::
   return

; disable alt-tab window switching, as we will be replacing it with the mac-style app switcher!
!Tab::
!+Tab::
   return

; since we are mapping control-tab to the app switcher, map windows-tab to the old control-tab behaviors
LWin & Tab::
RWin & Tab::
   controltab_active := 1
   GetKeyState, shiftpressed, Shift
   if (shiftpressed = "D") {
      SendInput, {Control down}{Shift down}{Tab}{Shift up}{Control up}
   } else {
      SendInput, {Control down}{Tab}{Control up}
   }
   controltab_active := 0
   return

; what we should implement here:
; ^h hides the active app
; ^q calls alt-F4 on every window in the app
; ^w calls alt-F4 on the current window
; for explorer, ^q does nothing and ^w does nothing on the desktop
; for chrome
; maybe there's some way to detect if the current app accepts command-W to close a tab or whatever, and if so use that automatically
; then if we can do that, use shift-command-Z when it isn't accepted but command-Y is, for redo
; beep on command-H if no other apps are showing

#if (switcher_active = 0 and controltab_active = 0)
^h::							; hide active program
   UpdateWindows()
   window_index := 0
   Loop, %program_0_window_count% {
      lookup_index := program_0_window_%window_index%
      DllCall("ShowWindow", uint, window_%lookup_index%_hwnd, int, 6) ; minimize
      window_index := window_index + 1
   }
   return

^m::
   UpdateWindows()
   lookup_index := program_0_window_0
   DllCall("ShowWindow", uint, window_%lookup_index%_hwnd, int, 6) ; minimize
   return

^+`::					; iterate through the open non-minimized windows of the active app
^`::
   UpdateWindows()
   topmost_index := -1
   nextmost_index := -1
   window_index := 0
   Loop, %program_0_window_count% {
      temp_index := program_0_window_%window_index%
      if (window_%temp_index%_iconic = false) {
         if (topmost_index = -1)
            topmost_index := temp_index
         else if (nextmost_index = -1)
            nextmost_index := temp_index
         bottommost_index := temp_index
      }
      window_index := window_index + 1
   }
   if (nextmost_index > -1) {
      if (A_ThisHotKey = "^`") {
         DllCall("SetWindowPos", int, window_%bottommost_index%_hwnd, int, window_%topmost_index%_hwnd, int, 0, int, 0, int, 0, int, 0, uint, 0x1 | 0x2)
      } else {
         DllCall("SetForegroundWindow", uint, window_%nextmost_index%_hwnd)
         DllCall("SetWindowPos", int, window_%topmost_index%_hwnd, int, window_%bottommost_index%_hwnd, int, 0, int, 0, int, 0, int, 0, uint, 0x1 | 0x2)
      }
   }
   return

^+Tab::
^Tab::
   if (active_index = -1) {
      return
   }
   UpdateWindows()
   if (A_ThisHotKey = "^Tab") {
      active_index := 1
      if (active_index >= program_count) {
         active_index := 0
      }
   } else {
      active_index := program_count - 1
   }
   
   VarSetCapacity(switcher_size, 8)
   NumPut(program_count * (AppSwitchIconSize + 16) - 16 + 16 * 2, switcher_size, 0)
   NumPut(AppSwitchIconSize + 26 + 16, switcher_size, 4)
   VarSetCapacity(switcher_pos, 8)
   SysGet, screen, Monitor, screen_index
   NumPut(screenLeft + (screenRight - screenLeft)/2 - NumGet(switcher_size, 0, true)/2, switcher_pos, 0)
   NumPut(screenTop + (screenBottom - screenTop)/2 - NumGet(switcher_size, 4, true)/2, switcher_pos, 4)
   if (switcher <> 0) {
      DllCall("MoveWindow", ptr, switcher, int, NumGet(switcher_pos, 0, true), int, NumGet(switcher_pos, 4, true), int, NumGet(switcher_size, 0, true), int, NumGet(switcher_size, 4, true), int, 0)
   } else {
      switcher := DllCall("CreateWindowExW", uint, 0x00000010 | 0x08000000 | 0x00000008, str, "#32770", str, "App Switcher", uint, 0x80000000, int, NumGet(switcher_pos, 0, true), int, NumGet(switcher_pos, 4, true), int, NumGet(switcher_size, 0, true), int, NumGet(switcher_size, 4, true), uint, 0, uint, 0, uint, DllCall("GetModuleHandleA", uint, 0), uint, 0)
      DllCall("SetWindowLongW", ptr, switcher, int, -4, ptr, RegisterCallback("WndProc", "F"))
      black_brush := DllCall("CreateSolidBrush", uint, 0x00000000)
      white_brush := DllCall("CreateSolidBrush", uint, 0x00FFFFFF)
   }
   DllCall("UpdateWindow", uint, switcher)
   start_time := A_TickCount
   switcher_active := 1
   switcher_visible := 0
   SetTimer, ShowSwitcher, -80
   KeyWait, Control
   if (active_index <> -1) {
      ; bring this app to the front!
      ; loop through all of the windows backwards, from bottom to top
      ;cur_window_count := program_%active_index%_window_count
      ;window_index := cur_window_count - 1
      ;Loop, %cur_window_count% {
      ;   lookup_index := program_%active_index%_window_%window_index%
      ;   DllCall("SetWindowPos", int, window_%lookup_index%_hwnd, int, window_0_hwnd, int, 0, int, 0, int, 0, int, 0, uint, 0x1 | 0x2)
      ;   window_index := window_index - 1
      ;}
      order_index := program_%active_index%_order
      program_window_count := program_%order_index%_window_count
      window_index := program_window_count - 1
      window_iconic := 0
      window_non_iconic := 0
      
      ; change this to set the first window to the front, then move the other windows immediately behind it
      ; this way if a SetForegroundWindow call fails we don't end up with the windows out of order!
      ; to do this, just call SetForegroundWindow on the first item in the list, then call SetWindowPost on the last item in the windows array for the rest of them
      
      Loop, %program_window_count% {
         ctrltab_global_index := program_%order_index%_window_%window_index%
         if (window_%ctrltab_global_index%_iconic) {
            window_iconic := window_%ctrltab_global_index%_hwnd
         } else { ;if (window_non_iconic = 0) { ; remove this condition to bring all app windows to the front (which is currently pretty flaky for some reason?)
            window_non_iconic := window_%ctrltab_global_index%_hwnd
            ;DllCall("SwitchToThisWindow", uint, window_non_iconic, int, 1)
            DllCall("SetForegroundWindow", uint, window_non_iconic)
            ;DllCall("SetWindowPos", int, window_non_iconic, int, 0, int, 0, int, 0, int, 0, int, 0, uint, 0x1 | 0x2)
         }
         window_index := window_index - 1
      }
      if (window_non_iconic = 0 and window_iconic <> 0) {
         DllCall("OpenIcon", uint, window_iconic)
         DllCall("SetForegroundWindow", uint, window_iconic)
      }
   }
   DllCall("ShowWindow", uint, switcher, uint, 0)
   SetTimer, ShowSwitcher, Off
   switcher_visible := 0
   switcher_active := 0
   active_index := 0
   return

ShowSwitcher:
   DllCall("ShowWindow", uint, switcher, uint, 5)
   switcher_visible := 1
   return

#if switcher_active = 1
^a::
^b::
^c::
^d::
^e::
^f::
^g::
^i::
^j::
^k::
^l::
^m::
^n::
^o::
^p::
^r::
^s::
^t::
^u::
^v::
^w::
^x::
^y::
^z::
^0::
^1::
^2::
^3::
^4::
^5::
^6::
^7::
^8::
^9::
^`::
^,::
^.::
^/::
^[::
^]::
^\::
^-::
^=::
^Backspace::
^Up::
^Down::
^PgUp::
^PgDn::
^Esc::
^F1::
^F2::
^F3::
^F4::
^F5::
^F6::
^F7::
^F8::
^F9::
^F10::
^F11::
^F12::
^F13::
^F14::
^F15::
   return
^Tab::					; select the next app
   KeyWait, Tab, T0.15
   SwitchRight()
   return
^Right::
   KeyWait, Right, T0.15
   SwitchRight()
   return
^+Tab::					; select the previous app
   KeyWait, Tab, T0.15
   SwitchLeft()
   return
^Left::
   KeyWait, Left, T0.15
   SwitchLeft()
   return
^Home::					; select the first app?
   return
^End::					; select the last app?
   return
^h::					; hide the selected app
   return
^q::					; quit the selected app
   return
^Enter::				; select this app!
^Return::
   return
^Escape::					; cancel the app switching
   SetTimer, ShowSwitcher, Off
   active_index := -1
   DllCall("ShowWindow", uint, switcher, uint, 0)
   switcher_visible := 0
   return
#if

SwitchLeft() {
   global
   if (switcher_active = 1 and active_index <> -1) {
      active_index := active_index - 1
      if (active_index < 0) {
         active_index := program_count - 1
      }
      DllCall("InvalidateRect", ptr, switcher, uint, 0, int, true)
   }
}

SwitchRight() {
   global
   if (switcher_active = 1 and active_index <> -1) {
      active_index := active_index + 1
      if (active_index >= program_count) {
         active_index := 0
      }
      DllCall("InvalidateRect", ptr, switcher, uint, 0, int, true)
   }
}

UpdateWindows() {
   global
   program_count := 0
   window_count := 0
   
   ; make a backup of all of the program and window information:
   ; actually, this shouldn't be necessary once we implement all of the event hooks
   ; program_count
   ; program_%i%_icon
   ; program_%i%_path
   ; program_%i%_name
   ; program_%i%_path_length
   ; program_%i%_name_length
   ; program_%i%_window_count
   ; program_%i%_window_%j%
   ; window_%k%_hwnd
   ; window_%k%_iconic
   
   DllCall("EnumWindows", ptr, RegisterCallback("EnumWindowsProc", "F"), int, 0)
   
   program_index := 0
   progman_active := WinActive("ahk_class Progman")
   Loop, %program_count% {
      if (program_%program_index%_icon = 0) {
         window_index := program_%program_index%_window_0
         ;icon := DllCall("SendMessage", uint, window_%window_index%_hwnd, uint, 0x7F, int, 0, int, 0)
         icon := DllCall("GetClassLong", ptr, window_%window_index%_hwnd, int, -34)
         program_%program_index%_icon := icon
      }
      program_%program_index%_order := program_index
      program_index := program_index + 1
   }
   
   if (WinActive("ahk_class Progman")) {
      program_0_order := progman_index
      program_index := 1
      while (program_index <= progman_index) {
         program_%program_index%_order := program_index - 1
         program_index := program_index + 1
      }
   }
   
   return
}

EnumWindowsProc(hwnd, lParam) {
   global
   
   iconic := DllCall("IsIconic", ptr, hwnd)
   VarSetCapacity(rect, 16)
   DllCall("GetWindowRect", ptr, hwnd, uint, &rect)
   rectLeft := NumGet(rect, 0, true)
   rectTop := NumGet(rect, 4, true)
   rectRight := NumGet(rect, 8, true)
   rectBottom := NumGet(rect, 12, true)
   
   ; as a quick fix to the window layering problem, change this to ignore floating windows
   VarSetCapacity(pwi, 60, 0)
   DllCall("GetWindowInfo", uint, hwnd, ptr, &pwi)
   exstyle := NumGet(pwi, 40, true)
   if (exstyle & 0x8 <> 0x8 and DllCall("IsWindowVisible", ptr, hwnd) and (iconic or (rectRight > rectLeft and rectBottom > rectTop))) {
      ; make sure the window is on one of the screens
      SysGet, screen_count, MonitorCount
      screen_index := 1
      Loop, %screen_count% {
         SysGet, screen, Monitor, screen_index
         if iconic or (rectRight >= screenLeft and rectLeft <= screenRight and rectBottom >= screenTop and rectTop <= screenBottom) {
            VarSetCapacity(pid, 4)
            DllCall("GetWindowThreadProcessId", ptr, hwnd, uint, &pid)
            processID := NumGet(pid, 0, true)
            handle := DllCall("OpenProcess", uint, 0x400, int, false, uint, processID)
            if (handle <> 0) {
               VarSetCapacity(size, 4)
               NumPut(65536, size)
               VarSetCapacity(path, 65536)
               if DllCall("QueryFullProcessImageNameW", uint, handle, uint, 0, uint, &path, uint, &size) <> 0 {
                  size2 := NumGet(size, 0, true)
                  path_length := size2
                  VarSetCapacity(icon, 4, 0)
                  val := DllCall("Shell32\ExtractIconExW", uint, &path, int, 0, uint, &icon, int, 0, int, 1)
                  icon := NumGet(icon, 0, true)
                  
                  ; get the file name (http://www.autohotkey.com/board/topic/52304-troubles-using-memcpy/)
                  i := path_length * 2
                  period := 0
                  while (i >= 0) {
                     character := NumGet(&path+i, 0, "short")
                     if (period = 0 and character = 46) {
                        ; we found the first period!
                        period := i
                     } else if (character = 92) {
                        if (period = 0) {
                           period = path_length * 2
                        }
                        VarSetCapacity(name, period - i, 0)
                        name_length := (period - i)/2 - 1
                        j := -1
                        while (++j < period - i - 2)
                           NumPut(NumGet(&path+i+j+2, 0, "UChar"), name, j, "UChar")
                        break
                     }
                     i := i - 2
                  }
                  
                  window_length := DllCall("GetWindowTextLengthW", uint, hwnd)
                  if (name <> "explorer" or window_length <> 0) {
                     is_progman := 0
                     if (name = "dllhost" or name = "rundll32") {
                        ; use the name and icon from the window instead
                        VarSetCapacity(name, window_length * 2 + 2, 0)
                        name_length := window_length
                        DllCall("GetWindowTextW", uint, hwnd, ptr, &name, uint, window_length * 2 + 2)
                        ; see if the name of the app is listed after " - " in the title, which is chr(32), chr(45), chr(32)
                        i := name_length * 2
                        while (i >= 4) {
                           if (NumGet(&name+i, 0, "short") = 32 and NumGet(&name+i-2, 0, "short") = 45 and NumGet(&name+i-4, 0, "short") = 32) {
                              VarSetCapacity(name2, name_length * 2 - i, 0)
                              j := -1
                              while (++j < name_length * 2 - i - 2)
                                 NumPut(NumGet(&name+i+j+2, 0, "UChar"), name2, j, "UChar")
                              name_length := (name_length * 2 - i - 2)/2
                              VarSetCapacity(name, name_length * 2 + 2, 0)
                              i := -1
                              while (++i < name_length * 2 + 2)
                                 NumPut(NumGet(&name2+i, 0, "UChar"), name, i, "UChar")
                              break
                           }
                           i := i - 2
                        }
                        
                        ;icon2 := DllCall("SendMessage", uint, hwnd, uint, 0x7F, int, 2, int, 0)
                        ;error := DllCall("GetLastError")
                        ;MsgBox, %error%
                        ;GetClassLongPtr(hwnd, GCL_HICON)
                        ;icon := DllCall("GetClassLongPtr", uint, hwnd, int, -14)
                        icon := 0
                        
                        ;MsgBox, %icon2%
                     } else {
                        VarSetCapacity(ignored, 4)
                        size3 := DllCall("Version\GetFileVersionInfoSizeW", uint, &path, uint, &ignored)
                        VarSetCapacity(buffer, size3, 0)
                        success := DllCall("Version\GetFileVersionInfoW", uint, &path, int, 0, int, size3, uint, &buffer)
                        VarSetCapacity(data, 4)
                        VarSetCapacity(len, 4)
                        success := DllCall("Version\VerQueryValueW", uint, &buffer, str, "\VarFileInfo\Translation", uint, &data, uint, &len)
                        if (success = 1) {
                           data2 := NumGet(data, 0, true)
                           data2 := NumGet(data2+0, 0, "short")
                           len2 := NumGet(data, 0, true)
                           len2 := NumGet(len2+0, 2, "short")
                           SetFormat, Integer, hex
                           data2 += 0
                           len2 += 0
                           SetFormat, Integer, d
                           StringReplace, data2, data2, 0x
                           digits := "0000"
                           StringLeft, digits, digits, 4 - StrLen(data2)
                           data2 := digits . data2
                           StringReplace, len2, len2, 0x
                           digits := "0000"
                           StringLeft, digits, digits, 4 - StrLen(len2)
                           len2 := digits . len2
                           success := DllCall("Version\VerQueryValueW", uint, &buffer, str, "\StringFileInfo\" . data2 . len2 . "\FileDescription", uint, &data, uint, &len)
                           len2 := NumGet(len, 0, true)
                           if (len2 > 0) {
                              data2 := NumGet(data, 0, true)
                              name_length := len2 - 1
                              VarSetCapacity(name, name_length * 2 + 2, 0)
                              i := -1
                              while (++i < name_length * 2 + 2)
                                 NumPut(NumGet(data2+i, 0, "UChar"), name, i, "UChar")
                              
                              if (name = "Windows Explorer") {
                                 icon := explorer_icon
                                 ; sorry, but i REALLY don't feel like learning the correct way to do this...
                                 name_length := 13
                                 VarSetCapacity(name, name_length * 2 + 2, 0)
                                 NumPut(70, name, 0, "short")
                                 NumPut(105, name, 2, "short")
                                 NumPut(108, name, 4, "short")
                                 NumPut(101, name, 6, "short")
                                 NumPut(32, name, 8, "short")
                                 NumPut(69, name, 10, "short")
                                 NumPut(120, name, 12, "short")
                                 NumPut(112, name, 14, "short")
                                 NumPut(108, name, 16, "short")
                                 NumPut(111, name, 18, "short")
                                 NumPut(114, name, 20, "short")
                                 NumPut(101, name, 22, "short")
                                 NumPut(114, name, 24, "short")
                                 is_progman := 1
                              } else if (name = "Windows WordPad Application") {
                                 name_length := 7
                                 VarSetCapacity(name, name_length * 2 + 2, 0)
                                 NumPut(87, name, 0, "short")
                                 NumPut(111, name, 2, "short")
                                 NumPut(114, name, 4, "short")
                                 NumPut(100, name, 6, "short")
                                 NumPut(80, name, 8, "short")
                                 NumPut(97, name, 10, "short")
                                 NumPut(100, name, 12, "short")
                              }
                           }
                        }
                     }
                     
                     program_index := 0
                     found_index := -1
                     Loop, %program_count% {
                        if (path_length = program_%program_index%_path_length) {
                           i := -1
                           matches := 1
                           while (++i < path_length * 2 + 2) {
                              if (NumGet(&path+i, 0, "UChar") <> NumGet(&program_%program_index%_path+i, 0, "UChar")) {
                                 matches = 0
                                 break
                              }
                           }
                           if (matches = 1) {
                              found_index := program_index
                              enumwnd_window_count := program_%found_index%_window_count
                              program_%program_index%_window_%enumwnd_window_count% := window_count
                              program_%program_index%_window_count := program_%program_index%_window_count + 1
                              break
                           }
                        }
                        program_index := program_index + 1
                     }
                     
                     if (found_index = -1) {
                        VarSetCapacity(program_%program_count%_path, path_length * 2 + 2)
                        i := -1
                        while (++i < path_length * 2 + 2)
                           NumPut(NumGet(&path+i, 0, "UChar"), program_%program_count%_path, i, "UChar")
                        program_%program_count%_path_length := path_length
                        program_%program_count%_icon := icon
                        program_%program_count%_name_length := name_length
                        VarSetCapacity(program_%program_count%_name, name_length * 2 + 2)
                        i := -1
                        while (++i < name_length * 2 + 2)
                           NumPut(NumGet(&name+i, 0, "UChar"), program_%program_count%_name, i, "UChar")
                        found_index := program_count
                        program_%program_count%_window_count := 1
                        program_%program_count%_window_0 := window_count
                        if (is_progman = 1)
                           progman_index := program_count
                        program_count := program_count + 1
                     }
                     
                     ; add this window to the global window list
                     window_%window_count%_hwnd := hwnd
                     window_%window_count%_iconic := iconic
                     ;window_%window_count%_program := found_index
                     ;window_%window_count%_index := program_%found_index%_window_count - 1
                     window_count := window_count + 1
                  }
               }
               
               DllCall("CloseHandle", uint32, handle)
            }
            break
         }
         screen_index := screen_index + 1
      }
   }
   
   return, 1
}

WndProc(hwnd, uMsg, wParam, lParam) {
   global
   
   if (uMsg = 0x0010) {
      DllCall("DestroyWindow", ptr, hwnd)
   } else if (uMsg = 0x002) {
      DllCall("PostQuitMessage", int, 0)
   } else if (uMsg = 0x00F) {
      VarSetCapacity(paint, 64)
      hdc := DllCall("BeginPaint", ptr, hwnd, uint, &paint)
      VarSetCapacity(rect, 16)
      DllCall("GetClientRect", ptr, hwnd, uint, &rect)
      DllCall("SetMapMode", uint, hdc, int, 1)
      DllCall("FillRect", uint, hdc, uint, &rect, uint, black_brush)
      
      x := 16
      y := 10
      program_index := 0
      Loop, %program_count% {
         if (program_index = active_index) {
            VarSetCapacity(r2, 16)
            NumPut(x - 4, r2, 0)
            NumPut(y - 4, r2, 4)
            NumPut(x - 4 + AppSwitchIconSize + 8, r2, 8)
            NumPut(y - 4 + AppSwitchIconSize + 8, r2, 12)
            DllCall("FillRect", uint, hdc, uint, &r2, uint, white_brush)
            NumPut(x - 3, r2, 0)
            NumPut(y - 3, r2, 4)
            NumPut(x - 3 + AppSwitchIconSize + 6, r2, 8)
            NumPut(y - 3 + AppSwitchIconSize + 6, r2, 12)
            DllCall("FillRect", uint, hdc, uint, &r2, uint, black_brush)
         }
         order_index := program_%program_index%_order
         if (program_%order_index%_icon <> 0) {
            DllCall("DrawIconEx", uint, hdc, int, x, int, y, uint, program_%order_index%_icon, int, AppSwitchIconSize, int, AppSwitchIconSize, int, 0, int, 0, int, 3)
         }
         x := x + AppSwitchIconSize + 16
         program_index := program_index + 1
      }
      
      DllCall("SetBkColor", uint, hdc, uint, 0x00000000)
      DllCall("SetTextColor", uint, hdc, uint, 0x00FFFFFF)
      
      VarSetCapacity(r2, 16)
      NumPut(10, r2, 0)
      NumPut(NumGet(switcher_size, 4, true) - 24, r2, 4)
      NumPut(10 + NumGet(switcher_size, 0, true) - 20, r2, 8)
      NumPut(NumGet(switcher_size, 4, true) - 24 + 20, r2, 12)
      order_index := program_%active_index%_order
      DllCall("DrawTextW", uint, hdc, ptr, &program_%order_index%_name, int, -1, uint, &r2, uint, 0x00000020 | 0x00000001 | 0x00000004 | 32768)
      
      DllCall("EndPaint", ptr, hwnd, uint, &paint)
   } else {
      return DllCall("DefWindowProcW", ptr, hwnd, int, uMsg, int, wParam, int, lParam)
   }
}

; http://l.autohotkey.net/docs/commands/_If.htm
ActiveControlIsOfClass(Class) {
   ControlGetFocus, FocusedControl, A
   ControlGet, FocusedControlHwnd, Hwnd,, %FocusedControl%, A
   WinGetClass, FocusedControlClass, ahk_id %FocusedControlHwnd%
   return (FocusedControlClass = Class)
}

ShowUserFolder(folder) {
   EnvGet, user_folder, USERPROFILE
   user_folder := user_folder . folder
   Run %user_folder%
   return
}

PowerProc(wParam, lParam) {
   if (lParam = 0 and (wParam = 7 or wParam = 8)) { ; system is waking up!
      Run "C:\Windows\System32\AppleControlPanel.exe"
      WinWait Boot Camp Control Panel
      WinGetPos, x, y, w, h, Boot Camp Control Panel
      winActivate, ahk_class Progman
      border := (w - 562)/2
      SetDefaultMouseSpeed, 0
      SetMouseDelay, -1
      ;MouseMove, x + border + 276, y + (h - 377 - border) + 20
      ;Click
   }
   return
}

DeviceProc(wParam, lParam) {
   global
   
   ; wParam: 32768 for volume mounted, 32772 for volume unmounted
   if ((wParam = 32768 or wParam = 32772) and NumGet(lParam+0, 0, true) = 20 and NumGet(lParam+4, 0, true) = 2) {
      ; figure out which volume was connected or disconnected
      letter_mask := NumGet(lParam+12, 0, true)
      letter_index := -1
      while (letter_mask > 0) {
         letter_mask := (letter_mask >> 1)
         letter_index := letter_index + 1
      }
      
      ; if we are mounting, create a shortcut for this drive on the Desktop and keep track of the path to the file
      ; if  we are unmounting, get the drive letter and remove the shortcut created for that drive
      drive_letter := chr(letter_index + 65)
      if (wParam = 32772) {
         file_path := drive_%drive_letter%
         if (file_path <> "")
            FileDelete, %file_path%
      } else if (wParam = 32768) {
         if (drive_letter = "Z") {
            ; mount the backup which is on the Time Capsule!
            Run "C:\Windows\System32\diskpart.exe /s `"C:\Program Files\Utilities\MountBackup.txt`""
         }
         
         target := drive_letter . ":\"
         DriveGet, drive_type, Type, target
         if (drive_type <> "Network" and drive_type <> "RAMDisk" and drive_letter <> "C" and drive_letter <> "Z" and drive_letter <> "B") {
            DriveGet, name, Label, %target%
            EnvGet, dir, USERPROFILE
            dir := dir . "\Desktop\" . name . ".lnk"
            FileCreateShortcut, %target%, %dir%
            drive_%drive_letter% := dir
         }
      }
   }
   return
}

; shell hook to set the icons on windows that are subsequently created
ShellMessage(wParam, lParam) {
   global menu_icon
   if wParam in 1,6,32772
      SendMessage, 0x80, 0, menu_icon, , % "ahk_id " . lParam ; set the gray triangle menu icon
}
